leetcode——169 Majority Element(数组中出现次数过半的元素)

Given an array of size n, find the majority element. The majority element is the element that appears more than  n/2  times.
You may assume that the array is non-empty and the majority element always exist in the array.

Hide Tags: Divide and Conquer Array Bit Manipulation

解题思路:
(1)使用HashMap。Map的特点:不同意反复元素,因此在存储前须要推断是否存在
(2)推断HashMap中存在nums[i],假设存在。使用hm.get(nums[i])获取value,即通过key来获得value值,即count(出现的次数)
(3)假设count大于数组长度的一般。即返回该元素
(4)假设count不满足条件,向HashMap存储元素以及出现的次数。


代码例如以下:

	public static int majorityElement(int[] nums)
	{
		/*
		 * Map的特点:不同意反复元素。因此在存储前须要推断是否存在
		 */
		Map<Integer, Integer> hm=new HashMap<Integer, Integer>();
		for (int i = 0; i < nums.length; i++)
		{
			int count=0;
			//推断HashMap中存在nums[i],假设存在,使用hm.get(nums[i])获取value
			//即通过key来获得value值,即count(出现的次数)
			if (hm.containsKey(nums[i]))
			{
				count=hm.get(nums[i])+1;
			}
			else
			{
				count=1;
			}
			//假设count大于数组长度的一般,即返回该元素
			if (count>nums.length/2)
			{
				return nums[i];
			}
			//向HashMap存储元素以及出现的次数
			hm.put(nums[i], count);
		}
		return 0;
		
	}

原文地址:https://www.cnblogs.com/bhlsheji/p/5390993.html